// A function promising unobtanium: an object with keys 'type' 'units' and 'grade'
const getUnobtanium = (delay = 0.5) => {
    return simulateDelay(delay)
       .then(() => { return 3.14 + Math.round(Math.random()*2-1) /* simulated scarcity */})
       .then(amount => ({ type: 'Unobtanium', grade: 'A++', units: amount }))
}

function simulateDelay(seconds) {
  return new Promise(resolve => setTimeout(resolve, seconds*1000))
}

// Well use this later!
function turnOnMusic() {
  console.log('More than a fee-linnnnnnnnnng')
}

await getUnobtanium(Math.random())
;

// lets use this as a standin for memcached or redis..
const cache = new Map

function startShipNaïvely() {
   let fuel
   if (cache.get('fuel')) {
    fuel = cache.get('fuel')
   } else {
    getUnobtanium().then(fuel => {
        /*
            start the ship with the fuel
        */
        cache.set('fuel', fuel) //and set it in the cache
    })
   }
}

;

'<img src="http://memedad.com/memes/172636.gif"/>';

// It's a matter of taste whether you take a promise for fuel, or the actual fuel as an argument
function startShipSmartly(promisedFuel) {
  return promisedFuel.then(fuel => {
    /* start ship */
    console.log('starting ship, vrooom...')
  })
}

await startShipSmartly(Promise.resolve('simulated fuel'));

await startShipSmartly(getPromisedFuel()).then(turnOnMusic);


/*  Sample implementaion of hiding caching logic from consumers (hard coded for one-key) */

// closes over our cache
function getPromisedFuel () {
  return new Promise((resolve, reject) => {
    console.log("getting fuel...")
    if (cache.get('fuel')) {
        return resolve(cache.get('fuel'))
    }

    // omitting the try/catch around this for demo purposes
    return getUnobtanium(.1).then(fuel => {
        console.log("got fuel, storing for later use")
        cache.set('fuel', fuel)
        return resolve(fuel)
    }).catch(ex => reject(ex))
  })
}
// To un-hardcode, you'd probably want the above abstracted a bit, with a function
// that can cache-wrap any function at any given key. The implementation of that 
// will be left as an exercise to the reader :)
// const dataSources = {
//    fuel: cacheWrap(getUnobtanium, 'fuel')
// }
await "Thanks for reading!";
